/*
 * Created on Apr 19, 2005
 *
 * TODO Implement it, then write some documentation
 *
 */
package se.umu.wsag.util;

/**
 * @author tordsson
 *
 * This class was included in the early prototype GT4 reserver
 * developed winter 2005 
 */

import java.io.BufferedReader; 
import java.io.InputStreamReader; 

import java.lang.Runtime; 
import java.lang.Process;

import org.apache.log4j.Logger;

public class Executor {

    private static Logger logger = 
        Logger.getLogger(Executor.class);
	
    // Execute command, return stdout from command. 
    // Throws exceptions if stderr is nonempty or if
    // process returns nonzero
    public static String runCommand(String command) throws Exception {
    	
    	logger.debug("Executing command: " + command); 

        Process process = Runtime.getRuntime().exec(command); 

        BufferedReader output = new BufferedReader(new InputStreamReader(
                    process.getInputStream())); 

        BufferedReader error = new BufferedReader(new InputStreamReader(
                    process.getErrorStream())); 

        String outputResult = ""; 
        String errorResult = ""; 
        String tmp = null; 

        while((tmp = output.readLine()) != null) 
            outputResult += tmp + "\n"; 

        tmp = null; 
        while((tmp = error.readLine()) != null) 
            errorResult += tmp + "\n"; 

        int returnCode = process.waitFor(); 
        process.destroy(); 

        if(returnCode != 0) {
        	logger.error("Command terminated abnormally"); 
            throw new Exception("Command " + command 
                    + " terminated abnormally\n"); 
        }
        if (errorResult != null && !errorResult.equals("")) {
        	logger.info("Command error message: " + errorResult); 
        	// We do not need to throw an Exception here, execution 
        	// ended normally after all...
            // throw new Exception(command + ": " + errorResult); 
        }
        
        // logger.debug("Returning: [" + outputResult + "]"); 

        return outputResult; 
    }
    
}